using System;
using System.IO;

namespace Siberix.Examples
{
	class Example
	{
		static void Main(string[] args)
		{
			// Report
			Siberix.Report.Report report = new Siberix.Report.Report();

			// Info
			report.Info.Title = "Example";
			report.Info.Author = "Siberix Technologies, Canada";
			report.Info.Creator = "Siberix Report Writer";
			report.Info.Copyright = "2003-2012 Siberix Technologies, Canada";

			// Section
			Siberix.Report.Section.ISection section = report.AddSection();
			section.Size = Siberix.Report.PageSize.Letter;
			section.Spacings.All = 35;

			// Canvas
			Siberix.Report.ICanvas canvas = section.AddCanvas();
			canvas.Height = new Siberix.Report.DirectHeight(400);

			// Rectangle
			canvas.StartHyperlink(0, 0, 10);
			canvas.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.Red, 5);
			canvas.Brush = new Siberix.Graphics.SolidColorBrush(new Siberix.Graphics.Color(255, 240, 240));
			canvas.DrawRectangle(50, 50, 150, 100, Siberix.Graphics.PaintMode.FillStroke);
			canvas.HyperlinkArea(50, 50, 150, 100);
			canvas.EndHyperlink();

			canvas.Font = new Siberix.Graphics.Fonts.TimesNewRomanItalic(18);
			canvas.Brush = Siberix.Graphics.Brushes.BlueViolet;
			canvas.DrawString(70, 90, "Go to first page");

			// Line
			canvas.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.Green, 5);
			canvas.DrawLine(220, 50, 320, 150);

			// Ellipse
			canvas.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.Blue, 5);
			canvas.Brush = new Siberix.Graphics.SolidColorBrush(new Siberix.Graphics.Color(240, 240, 255));
			canvas.DrawEllipse(340, 50, 150, 100, Siberix.Graphics.PaintMode.FillStroke);

			// Path
			canvas.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.DarkBlue, 5, Siberix.Graphics.DashStyle.DashDot);
			canvas.Brush = new Siberix.Graphics.LinearGradientBrush(Siberix.Graphics.Colors.Yellow, Siberix.Graphics.Colors.Green, 45F);

			canvas.StartShape(Siberix.Graphics.PaintMode.FillStroke);
			canvas.FillRectangle(120, 200, 200, 200);
			canvas.DrawEllipse(220, 250, 200, 200);
			canvas.EndShape();

			// Publish
			report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF);
			report.Publish("Document.xps", Siberix.Report.FileFormat.XPS);

			// Save
			report.Save("Document.xml");

			// View
			System.Diagnostics.Process process = new System.Diagnostics.Process();
			System.Diagnostics.ProcessStartInfo info = new System.Diagnostics.ProcessStartInfo("Document.pdf");
			process.StartInfo = info;
			process.Start();
		}
	}
}