using System.Collections.Generic;

namespace Siberix.Examples
{
	using System;

	class Example
	{
		static void Main(string[] args)
		{
			// Report
			Siberix.Report.Report report = new Siberix.Report.Report();

			// Info
			report.Info.Title = "Example";
			report.Info.Author = "Siberix Technologies, Canada";
			report.Info.Creator = "Siberix Report Writer";
			report.Info.Copyright = "2003-2012 Siberix Technologies, Canada";

			// Section
			Siberix.Report.Section.ISection section = report.AddSection();
			section.Size = Siberix.Report.PageSize.Letter;
			section.Spacings.All = 35;

			// Styles
			Siberix.Report.Text.Style style1 = new Siberix.Report.Text.Style(new Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black);

			Siberix.Report.Text.Style style2 = new Siberix.Report.Text.Style(new Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Red);
			style2.FontVariant = Siberix.Report.FontVariant.Subscript;

			Siberix.Report.Text.Style style3 = new Siberix.Report.Text.Style(new Siberix.Graphics.Fonts.Arial(16), Siberix.Graphics.Brushes.White);

			// Grid
			Siberix.Report.Grid.IGrid grid = section.AddGrid();
			grid.StretchOnBreak = true;
			grid.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			grid.Borders.Corners.TopLeft.Pen = Siberix.Graphics.Pens.Black;
			grid.Borders.Corners.TopLeft.Radius = 10;
			grid.Borders.Corners.BottomLeft.Pen = Siberix.Graphics.Pens.Black;
			grid.Borders.Corners.BottomLeft.Radius = 10;

			Siberix.Report.Grid.IColumn column = grid.AddColumn();
			column.Width = new Siberix.Report.RelativeWidth(20);

			column = grid.AddColumn();
			column.Width = new Siberix.Report.DirectWidth(100);

			column = grid.AddColumn();
			column.Width = new Siberix.Report.RelativeWidth(20);

			column = grid.AddColumn();
			column.Width = new Siberix.Report.RelativeWidth(30);

			column = grid.AddColumn();
			column.Width = new Siberix.Report.RelativeWidth(30);

			// Header
			Siberix.Report.Grid.IHeader header = grid.AddHeader();
			header.Repeat = true;

			Siberix.Report.Grid.IRow row = header.AddRow();
			row.Height = new Siberix.Report.DirectHeight(35);

			Siberix.Report.Grid.ICell cell = row.AddCell();
			cell.ColSpan = 5;
			cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Borders.Corners.TopLeft.Pen = Siberix.Graphics.Pens.Black;
			cell.Borders.Corners.TopLeft.Radius = 10;
			cell.Background = new Siberix.Report.Background(new Siberix.Graphics.Color(235, 50, 50));

			Siberix.Report.Text.IText text = cell.AddText();
			text.Width = new Siberix.Report.RelativeWidth(100);
			text.Style = style3;
			text.Alignment = Siberix.Report.TextAlignment.Center;
			text.AddContent("Header");

			// Footer
			Siberix.Report.Grid.IFooter footer = grid.AddFooter();
			footer.Repeat = true;

			row = footer.AddRow();
			row.Height = new Siberix.Report.DirectHeight(35);

			cell = row.AddCell();
			cell.ColSpan = 5;
			cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Borders.Corners.BottomLeft.Pen = Siberix.Graphics.Pens.Black;
			cell.Borders.Corners.BottomLeft.Radius = 10;
			cell.Background = new Siberix.Report.Background(new Siberix.Graphics.Color(50, 200, 200));

			text = cell.AddText();
			text.Width = new Siberix.Report.RelativeWidth(100);
			text.Style = style3;
			text.Alignment = Siberix.Report.TextAlignment.Center;
			text.AddContent("Footer");

			// Last footer
			Siberix.Report.Grid.IFooter lastFooter = grid.AddFooter();
			lastFooter.Repeat = false;

			row = lastFooter.AddRow();
			row.Height = new Siberix.Report.DirectHeight(55);

			cell = row.AddCell();
			cell.ColSpan = 5;
			cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Borders.Corners.BottomLeft.Pen = Siberix.Graphics.Pens.Black;
			cell.Borders.Corners.BottomLeft.Radius = 10;
			cell.Background = new Siberix.Report.Background(new Siberix.Graphics.Color(125, 50, 200));

			text = cell.AddText();
			text.Width = new Siberix.Report.RelativeWidth(100);
			text.Style = style3;
			text.Alignment = Siberix.Report.TextAlignment.Center;
			text.AddContent("Last Footer");

			row = grid.AddRow();

			cell = row.AddCell();
			cell.RowSpan = 2;
			cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Paddings.All = 5;

			text = cell.AddText();
			text.Style = style1;
			text.AddContent("row");
			text.AddContent("1", style2);
			text.AddContent(" cell");
			text.AddContent("1", style2);
			text.AddContent(" content...");

			cell = row.AddCell();
			cell.RowSpan = 4;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Paddings.All = 5;

			text = cell.AddText();
			text.Style = style1;
			text.AddContent("row");
			text.AddContent("1", style2);
			text.AddContent(" cell");
			text.AddContent("2", style2);
			text.AddContent(" content... Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive \"raisiny\" flavor.");

			cell = row.AddCell();
			cell.RowSpan = 2;
			cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Paddings.All = 5;

			text = cell.AddText();
			text.Style = style1;
			text.AddContent("row");
			text.AddContent("1", style2);
			text.AddContent(" cell");
			text.AddContent("3", style2);
			text.AddContent(" content...");

			cell = row.AddCell();
			cell.ColSpan = 2;
			cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Paddings.All = 5;

			text = cell.AddText();
			text.Style = style1;
			text.AddContent("row");
			text.AddContent("1", style2);
			text.AddContent(" cell");
			text.AddContent("4", style2);
			text.AddContent(" content...");

			row = grid.AddRow();

			cell = row.AddCell();
			cell.ColSpan = 2;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Paddings.All = 5;

			text = cell.AddText();
			text.Style = style1;
			text.AddContent("row");
			text.AddContent("2", style2);
			text.AddContent(" cell");
			text.AddContent("1", style2);
			text.AddContent(" content... Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique.");

			row = grid.AddRow();

			cell = row.AddCell();
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Paddings.All = 5;

			text = cell.AddText();
			text.Style = style1;
			text.AddContent("row");
			text.AddContent("3", style2);
			text.AddContent(" cell");
			text.AddContent("1", style2);
			text.AddContent(" content...");

			cell = row.AddCell();
			cell.ColSpan = 2;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Paddings.All = 5;

			text = cell.AddText();
			text.Style = style1;
			text.AddContent("row");
			text.AddContent("3", style2);
			text.AddContent(" cell");
			text.AddContent("2", style2);
			text.AddContent(" content...");
			text.Spacings.Bottom = 5;

			Siberix.Report.IImage image = cell.AddImage(new Siberix.Graphics.Image("../../image.jpg"));
			image.Width = new Siberix.Report.RelativeWidth(100);

			cell = row.AddCell();
			cell.RowSpan = 2;
			cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Paddings.All = 5;
			cell.Background = new Siberix.Report.Background(new Siberix.Graphics.Color(230, 230, 230));

			text = cell.AddText();
			text.Style = style1;
			text.AddContent("row");
			text.AddContent("3", style2);
			text.AddContent(" cell");
			text.AddContent("3", style2);
			text.AddContent(" content...");

			row = grid.AddRow();

			cell = row.AddCell();
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Paddings.All = 5;

			text = cell.AddText();
			text.Style = style1;
			text.AddContent("row");
			text.AddContent("4", style2);
			text.AddContent(" cell");
			text.AddContent("1", style2);
			text.AddContent(" content...");

			cell = row.AddCell();
			cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Bottom;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Paddings.All = 5;
			cell.Background = new Siberix.Report.Background(new Siberix.Graphics.Color(230, 230, 230));

			text = cell.AddText();
			text.Style = style1;
			text.AddContent("row");
			text.AddContent("4", style2);
			text.AddContent(" cell");
			text.AddContent("2", style2);
			text.AddContent(" content...");

			cell = row.AddCell();
			cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Bottom;
			cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
			cell.Paddings.All = 5;

			text = cell.AddText();
			text.Style = style1;
			text.AddContent("row");
			text.AddContent("4", style2);
			text.AddContent(" cell");
			text.AddContent("3", style2);
			text.AddContent(" content...");

			System.Random rnd = new System.Random();

			for (int i = 5; i < 21; i++)
			{
				row = grid.AddRow();

				cell = row.AddCell();
				cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
				cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle;
				cell.Paddings.All = 5;

				text = cell.AddText();
				text.Style = style1;
				text.AddContent("row");
				text.AddContent(i.ToString(), style2);
				text.AddContent(" cell");
				text.AddContent("1", style2);
				text.AddContent(" content...");

				cell = row.AddCell();
				cell.ColSpan = 4;
				cell.Borders = new Siberix.Report.Borders(Siberix.Graphics.Pens.Black);
				cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle;
				cell.Paddings.All = 5;

				text = cell.AddText();
				text.Style = style1;
				text.Spacings.Bottom = 5;
				text.AddContent("row");
				text.AddContent(i.ToString(), style2);
				text.AddContent(" cell");
				text.AddContent("2", style2);
				text.AddContent(" content... Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive \"raisiny\" flavor.");

				int j = 0;
				int cnt = rnd.Next(5);

				while (j < cnt)
				{
					j++;

					text.AddLineBreak();
					text.AddContent("... extra text line");
					text.AddContent(j.ToString(), style2);
				}
			}

			// Publish
			report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF);
			report.Publish("Document.xps", Siberix.Report.FileFormat.XPS);

			// Save
			report.Save("Report.xml");

			// View
			System.Diagnostics.Process process = new System.Diagnostics.Process();
			System.Diagnostics.ProcessStartInfo info = new System.Diagnostics.ProcessStartInfo("Document.pdf");
			process.StartInfo = info;
			process.Start();
		}
	}
}