namespace Siberix.Examples
{
	class Example
	{
		static void Main(string[] args)
		{
			// Report
			Siberix.Report.Report report = new Siberix.Report.Report();

			// Info
			report.Info.Title = "Example";
			report.Info.Author = "Siberix Technologies, Canada";
			report.Info.Creator = "Siberix Report Writer";
			report.Info.Copyright = "2003-2012 Siberix Technologies, Canada";

			// Section
			Siberix.Report.Section.ISection section = report.AddSection();
			section.Size = Siberix.Report.PageSize.Letter;
			section.Spacings.All = 35;

			// LEAF
			Siberix.Readers.LEAF.IDocument document = Siberix.Readers.LEAF.DocumentReader.Read("../../Example.leaf");

			// Canvas
			Siberix.Report.ICanvas canvas = section.AddCanvas();
			canvas.Height = new Siberix.Report.RelativeHeight(100);

			// Graphics
			Siberix.Graphics.IGraphics graphics = canvas.AsGraphics();
			graphics.Scale(0.5F, 0.5F);
			graphics.Translate(150, 50);
			graphics.Rotate(50, 50, 25);

			// Page
			Siberix.Readers.LEAF.IPage page = document.Pages[0];
			page.Render(graphics);

			// Publish
			report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF);
			report.Publish("Document.xps", Siberix.Report.FileFormat.XPS);

			// Save
			report.Save("Report.xml");

			// View
			System.Diagnostics.Process process = new System.Diagnostics.Process();
			System.Diagnostics.ProcessStartInfo info = new System.Diagnostics.ProcessStartInfo("Document.pdf");
			process.StartInfo = info;
			process.Start();
		}
	}
}