namespace Siberix.Examples
{
	class Example
	{
		static void Main(string[] args)
		{
			// Report
			Siberix.Report.Report report = new Siberix.Report.Report();

			// Info
			report.Info.Title = "Example";
			report.Info.Author = "Siberix Technologies, Canada";
			report.Info.Creator = "Siberix Report Writer";
			report.Info.Copyright = "2003-2012 Siberix Technologies, Canada";

			// Section
			Siberix.Report.Section.ISection section = report.AddSection();
			section.Size = Siberix.Report.PageSize.Letter;
			section.Spacings.All = 35;

			// HTML Paragraph
			Siberix.Report.Text.IText text = section.AddText();
			text.Spacings.Bottom = 25;
			text.AddHTMLContent("Regular text<br><i>Italic text</i><br><b>Bold text<br><i>Bold-Italic text</b></i><br><font color=YellowGreen>Colored text</font><br>Hyperlink to <a href=http://www.siberix.com><font color=Blue><u>www.siberix.com</u></font></a><br>Unicode (Arial glyph 0x215E): <font name=Arial>" + (char)0x215E + "</font>");
			text.AddLineBreak();
			text.AddHTMLContent("<img src=../../image.jpg width=100>");

			// RTF Paragraph
			text = section.AddText();

			System.IO.FileStream fs = new System.IO.FileStream("../../Example.rtf", System.IO.FileMode.Open, System.IO.FileAccess.Read);

			text.AddRTFContent(fs);

			fs.Close();

			// Publish
			report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF);
			report.Publish("Document.xps", Siberix.Report.FileFormat.XPS);

			// Save
			report.Save("Report.xml");

			// View
			System.Diagnostics.Process process = new System.Diagnostics.Process();
			System.Diagnostics.ProcessStartInfo info = new System.Diagnostics.ProcessStartInfo("Document.pdf");
			process.StartInfo = info;
			process.Start();
		}
	}
}