Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Encryption
        report.Preferences.PDF.Encryptor.Password.User = "test"
        report.Preferences.PDF.Encryptor.Password.Owner = "siberix"

        report.Preferences.PDF.Encryptor.Permissions.Add = False
        report.Preferences.PDF.Encryptor.Permissions.Copy = False
        report.Preferences.PDF.Encryptor.Permissions.Modify = False
        report.Preferences.PDF.Encryptor.Permissions.Print = True

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black)

        Dim text As Siberix.Report.Text.IText = section.AddText()
        text.Style = style1
        text.AddContent("This document is encrypted.")

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
