Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' TIFF
        Dim tiff As System.Drawing.Image = System.Drawing.Image.FromFile("../../image.tiff")

        Dim dimension As System.Drawing.Imaging.FrameDimension = New System.Drawing.Imaging.FrameDimension(tiff.FrameDimensionsList(0))

        Dim i As Integer = 0
        Dim cnt As Integer = tiff.GetFrameCount(dimension)

        While i < cnt
            tiff.SelectActiveFrame(dimension, i)

            Dim img As Siberix.Wrappers.GDIPlus.Image = New Wrappers.GDIPlus.Image(tiff, Graphics.PixelFormat.BW)

            Dim image As Siberix.Report.IImage = section.AddImage(img)

            image.Width = New Siberix.Report.RelativeWidth(95)

            'image.Width = new Siberix.Report.FixedWidth(tiff.Width / tiff.HorizontalResolution * 72)
            'image.Height = new Siberix.Report.FixedHeight(tiff.Height / tiff.VerticalResolution * 72)

            i += 1

        End While

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
