Imports System.Security.Cryptography.X509Certificates

Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' You can use the following lines to create test certificates. Makecert.exe is a part of Visual Studio 2010 SDK.

        ' makecert.exe -n "CN=MyRootCert" -cy authority -m 12 -r -ss "Root" -sr "LocalMachine"
        ' makecert.exe -n "CN=MyCert1" -cy end -m 12 -is "Root" -in "MyRootCert" -ir "LocalMachine" -ss "My" -sr "CurrentUser"

        ' Signature
        Dim store As X509Store = New X509Store(StoreName.My, StoreLocation.CurrentUser)

        store.Open(OpenFlags.ReadOnly)

        Dim certificates As X509Certificate2Collection = store.Certificates.Find(X509FindType.FindBySubjectName, "MyCert1", True)

        store.Close()

        report.Preferences.PDF.Signature.Certificate = certificates(0)
        report.Preferences.PDF.Signature.Reason = "I agree..."
        report.Preferences.PDF.Signature.Location = "Canada"
        report.Preferences.PDF.Signature.ContactInfo = "Phone: (778) 855-0655"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black)

        Dim text As Siberix.Report.Text.IText = section.AddText()
        text.Style = style1
        text.AddContent("This document is signed.")

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
